/* A Bison parser, made from sg.y, by GNU bison 1.75.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON	1

/* Pure parsers.  */
#define YYPURE	0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     ADMINISTRATOR = 258,
     QSTRING = 259,
     CHECK_PROXY_TUNNELS = 260,
     QUEUE_CHECKS = 261,
     AGRESSIVE = 262,
     LOG_ONLY = 263,
     OFF = 264,
     HTTPS_CONNECTION_CACHE_SIZE = 265,
     WORD = 266,
     END = 267,
     START_BRACKET = 268,
     STOP_BRACKET = 269,
     WEEKDAY = 270,
     DESTINATION = 271,
     REWRITE = 272,
     ACL = 273,
     PORT = 274,
     CPUS = 275,
     TIME = 276,
     TVAL = 277,
     DVAL = 278,
     DVALCRON = 279,
     SOURCE = 280,
     CIDR = 281,
     IPCLASS = 282,
     CONTINUE = 283,
     IPADDR = 284,
     DBHOME = 285,
     DOMAINLIST = 286,
     URLLIST = 287,
     EXPRESSIONLIST = 288,
     IPLIST = 289,
     DOMAIN = 290,
     USER = 291,
     USERLIST = 292,
     USERQUOTA = 293,
     IP = 294,
     NL = 295,
     NUMBER = 296,
     NUMBERS = 297,
     PASS = 298,
     REDIRECT = 299,
     LOGDIR = 300,
     SUBST = 301,
     CHAR = 302,
     MINUTELY = 303,
     HOURLY = 304,
     DAILY = 305,
     WEEKLY = 306,
     DATE = 307,
     WITHIN = 308,
     OUTSIDE = 309,
     ELSE = 310,
     LOGFILE = 311,
     ANONYMOUS = 312,
     CONTINIOUS = 313,
     SPORADIC = 314,
     ANALYSE_UNCATEGORISED = 315
   };
#endif
#define ADMINISTRATOR 258
#define QSTRING 259
#define CHECK_PROXY_TUNNELS 260
#define QUEUE_CHECKS 261
#define AGRESSIVE 262
#define LOG_ONLY 263
#define OFF 264
#define HTTPS_CONNECTION_CACHE_SIZE 265
#define WORD 266
#define END 267
#define START_BRACKET 268
#define STOP_BRACKET 269
#define WEEKDAY 270
#define DESTINATION 271
#define REWRITE 272
#define ACL 273
#define PORT 274
#define CPUS 275
#define TIME 276
#define TVAL 277
#define DVAL 278
#define DVALCRON 279
#define SOURCE 280
#define CIDR 281
#define IPCLASS 282
#define CONTINUE 283
#define IPADDR 284
#define DBHOME 285
#define DOMAINLIST 286
#define URLLIST 287
#define EXPRESSIONLIST 288
#define IPLIST 289
#define DOMAIN 290
#define USER 291
#define USERLIST 292
#define USERQUOTA 293
#define IP 294
#define NL 295
#define NUMBER 296
#define NUMBERS 297
#define PASS 298
#define REDIRECT 299
#define LOGDIR 300
#define SUBST 301
#define CHAR 302
#define MINUTELY 303
#define HOURLY 304
#define DAILY 305
#define WEEKLY 306
#define DATE 307
#define WITHIN 308
#define OUTSIDE 309
#define ELSE 310
#define LOGFILE 311
#define ANONYMOUS 312
#define CONTINIOUS 313
#define SPORADIC 314
#define ANALYSE_UNCATEGORISED 315




/* Copy the first part of user declarations.  */
#line 1 "sg.y"


/*
  By accepting this notice, you agree to be bound by the following
  agreements:
  
  ufdbGuard is copyrighted (C) 2005,2006 by URLfilterDB with all rights reserved.
  ufdbGuard is based on squidGuard.

  squidGuard is copyrighted (C) 1998 by
  ElTele st AS, Oslo, Norway, with all rights reserved.
  
  This program is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License (version 2) as
  published by the Free Software Foundation.  It is distributed in the
  hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
  implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
  PURPOSE.  See the GNU General Public License (GPL) for more details.
  
  You should have received a copy of the GNU General Public License
  (GPL) along with this program.
*/


/* #define YYDEBUG 1 */

#include "sg.h"
#include "ufdb.h"
#include "ufdblib.h"
#include "ufdbchkport.h"

#include <netdb.h>

FILE * yyin;
FILE * yyout;
char * configFile;

extern struct Setting * lastSetting ;
extern struct Setting * Setting;

extern struct Source * lastSource ;
extern struct Source * Source ;

extern struct Destination * lastDest ;
extern struct Destination * Dest ;

extern struct sgRewrite * lastRewrite;
extern struct sgRewrite * Rewrite;
extern struct ufdbRegExp *  lastRewriteRegExec;

extern struct Time * lastTime;
extern struct Time * Time;

extern struct LogFile * globalLogFile;

extern struct LogFileStat * lastLogFileStat;
extern struct LogFileStat * LogFileStat;

extern struct TimeElement * lastTimeElement;
extern struct TimeElement * TimeElement;

int   numTimeElements;
int * TimeElementsEvents = NULL;

extern struct Acl * lastAcl;
extern struct Acl * defaultAcl;
extern struct Acl * Acl;
extern struct AclDest * lastAclDest;
 
extern struct UFDBmemTable knownDb;

extern struct ufdbRegExp * lastRegExpDest;

extern char * globalLogDir; /* from main.c */
extern int    analyseUncategorised;
extern int    httpsConnectionCacheSize;

extern int globalDebugTimeDelta;

static int time_switch = 0;
static int date_switch = 0;

int numSource = 0;
int portNum = UFDB_DAEMON_PORT;



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#ifndef YYSTYPE
#line 88 "sg.y"
typedef union {
  char * string;
  char * tval;
  char * dval;
  char * dvalcron;
  int    integer;
} yystype;
/* Line 193 of /usr/share/bison/yacc.c.  */
#line 288 "y.tab.c"
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif

#ifndef YYLTYPE
typedef struct yyltype
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} yyltype;
# define YYLTYPE yyltype
# define YYLTYPE_IS_TRIVIAL 1
#endif

/* Copy the second part of user declarations.  */


/* Line 213 of /usr/share/bison/yacc.c.  */
#line 309 "y.tab.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYLTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAX (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAX)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];	\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAX;	\
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  3
#define YYLAST   170

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  65
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  57
/* YYNRULES -- Number of rules. */
#define YYNRULES  140
/* YYNRULES -- Number of states. */
#define YYNSTATES  207

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   315

#define YYTRANSLATE(X) \
  ((unsigned)(X) <= YYMAXUTOK ? yytranslate[X] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    64,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    63,    61,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,    62,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short yyprhs[] =
{
       0,     0,     3,     5,     8,    10,    12,    14,    16,    19,
      22,    25,    28,    31,    34,    37,    40,    42,    44,    47,
      52,    53,    56,    59,    62,    65,    68,    71,    75,    78,
      81,    84,    87,    90,    93,    97,   100,   103,   108,   109,
     112,   115,   118,   121,   126,   131,   136,   141,   144,   147,
     150,   153,   157,   160,   162,   163,   166,   169,   170,   173,
     176,   181,   182,   185,   187,   191,   195,   200,   201,   211,
     212,   215,   218,   221,   224,   228,   231,   232,   235,   239,
     242,   244,   246,   247,   250,   254,   258,   263,   266,   268,
     271,   276,   277,   280,   282,   285,   288,   292,   295,   298,
     303,   304,   307,   308,   309,   315,   316,   317,   323,   324,
     328,   329,   335,   339,   342,   344,   349,   353,   356,   358,
     360,   362,   364,   366,   367,   370,   372,   374,   376,   378,
     380,   382,   384,   386,   388,   390,   392,   394,   396,   398,
     400
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      66,     0,    -1,   120,    -1,    10,    41,    -1,     9,    -1,
       6,    -1,     7,    -1,     8,    -1,     5,    68,    -1,     3,
       4,    -1,    30,    11,    -1,    45,    11,    -1,    19,    41,
      -1,    20,    41,    -1,    20,    42,    -1,    60,    41,    -1,
      13,    -1,    14,    -1,    16,    11,    -1,    78,    76,    80,
      77,    -1,    -1,    80,    81,    -1,    31,    11,    -1,    31,
      61,    -1,    32,    11,    -1,    32,    61,    -1,    33,    61,
      -1,    33,    62,    11,    -1,    33,    11,    -1,    44,    11,
      -1,    44,     4,    -1,    17,    11,    -1,    53,    11,    -1,
      54,    11,    -1,    56,    57,    11,    -1,    56,    11,    -1,
      25,    11,    -1,    82,    76,    84,    77,    -1,    -1,    84,
      85,    -1,    35,    86,    -1,    36,    87,    -1,    37,    11,
      -1,    38,    41,    41,    49,    -1,    38,    41,    41,    50,
      -1,    38,    41,    41,    51,    -1,    38,    41,    41,    41,
      -1,    39,    98,    -1,    34,    11,    -1,    53,    11,    -1,
      54,    11,    -1,    56,    57,    11,    -1,    56,    11,    -1,
      28,    -1,    -1,    86,    11,    -1,    86,    63,    -1,    -1,
      87,    11,    -1,    87,    63,    -1,    18,    76,    89,    77,
      -1,    -1,    89,    91,    -1,    11,    -1,    11,    53,    11,
      -1,    11,    54,    11,    -1,    90,    76,    93,    77,    -1,
      -1,    90,    76,    93,    77,    55,    92,    76,    93,    77,
      -1,    -1,    93,    94,    -1,    43,    95,    -1,    17,    11,
      -1,    44,    11,    -1,    56,    57,    11,    -1,    56,    11,
      -1,    -1,    95,    11,    -1,    95,    64,    11,    -1,    95,
      63,    -1,    26,    -1,    27,    -1,    -1,    98,    99,    -1,
      98,    99,    96,    -1,    98,    99,    97,    -1,    98,    99,
      61,    99,    -1,    98,    63,    -1,    29,    -1,    17,    11,
      -1,   100,    76,   102,    77,    -1,    -1,   102,   103,    -1,
      46,    -1,    53,    11,    -1,    54,    11,    -1,    56,    57,
      11,    -1,    56,    11,    -1,    21,    11,    -1,   104,    76,
     106,    77,    -1,    -1,   106,   107,    -1,    -1,    -1,    51,
     108,    11,   109,   113,    -1,    -1,    -1,    51,   110,    15,
     111,   113,    -1,    -1,    52,   112,   115,    -1,    -1,   113,
     114,   117,    61,   117,    -1,   117,    61,   117,    -1,   116,
     113,    -1,   116,    -1,   116,    61,   116,   113,    -1,   116,
      61,   116,    -1,   118,   113,    -1,   118,    -1,    23,    -1,
      22,    -1,    24,    -1,     1,    -1,    -1,   120,   121,    -1,
      78,    -1,    83,    -1,    79,    -1,    70,    -1,    67,    -1,
      69,    -1,    71,    -1,    72,    -1,    73,    -1,    74,    -1,
      75,    -1,    88,    -1,   101,    -1,   105,    -1,   119,    -1,
      40,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,   135,   135,   138,   142,   144,   145,   146,   149,   153,
     156,   159,   162,   165,   166,   169,   173,   177,   181,   184,
     188,   189,   192,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   209,   212,   215,   216,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   236,   237,   238,   241,   242,   243,
     246,   249,   250,   253,   254,   255,   258,   260,   259,   264,
     265,   268,   269,   270,   271,   272,   275,   276,   277,   278,
     281,   284,   286,   287,   288,   289,   290,   291,   294,   297,
     299,   302,   303,   307,   308,   309,   310,   311,   315,   317,
     320,   321,   325,   325,   325,   326,   326,   326,   327,   327,
     330,   330,   331,   334,   335,   336,   337,   338,   339,   342,
     345,   348,   351,   356,   357,   360,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "ADMINISTRATOR", "QSTRING", 
  "CHECK_PROXY_TUNNELS", "QUEUE_CHECKS", "AGRESSIVE", "LOG_ONLY", "OFF", 
  "HTTPS_CONNECTION_CACHE_SIZE", "WORD", "END", "START_BRACKET", 
  "STOP_BRACKET", "WEEKDAY", "DESTINATION", "REWRITE", "ACL", "PORT", 
  "CPUS", "TIME", "TVAL", "DVAL", "DVALCRON", "SOURCE", "CIDR", "IPCLASS", 
  "CONTINUE", "IPADDR", "DBHOME", "DOMAINLIST", "URLLIST", 
  "EXPRESSIONLIST", "IPLIST", "DOMAIN", "USER", "USERLIST", "USERQUOTA", 
  "IP", "NL", "NUMBER", "NUMBERS", "PASS", "REDIRECT", "LOGDIR", "SUBST", 
  "CHAR", "MINUTELY", "HOURLY", "DAILY", "WEEKLY", "DATE", "WITHIN", 
  "OUTSIDE", "ELSE", "LOGFILE", "ANONYMOUS", "CONTINIOUS", "SPORADIC", 
  "ANALYSE_UNCATEGORISED", "'-'", "'i'", "','", "'!'", "$accept", "start", 
  "https_cache_size", "check_proxy_tunnel_option", "check_proxy_tunnels", 
  "admin_spec", "dbhome", "logdir", "port", "cpus", 
  "analyse_uncategorised", "start_block", "stop_block", "destination", 
  "destination_block", "destination_contents", "destination_content", 
  "source", "source_block", "source_contents", "source_content", "domain", 
  "user", "acl_block", "acl_contents", "acl", "acl_content", "@1", 
  "access_contents", "access_content", "access_pass", "cidr", "ipclass", 
  "ips", "ip", "rew", "rew_block", "rew_contents", "rew_content", "time", 
  "time_block", "time_contents", "time_content", "@2", "@3", "@4", "@5", 
  "@6", "ttime", "@7", "date", "dval", "tval", "dvalcron", "an_error", 
  "statements", "statement", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    45,   105,    44,    33
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    65,    66,    67,    68,    68,    68,    68,    69,    70,
      71,    72,    73,    74,    74,    75,    76,    77,    78,    79,
      80,    80,    81,    81,    81,    81,    81,    81,    81,    81,
      81,    81,    81,    81,    81,    81,    82,    83,    84,    84,
      85,    85,    85,    85,    85,    85,    85,    85,    85,    85,
      85,    85,    85,    85,    86,    86,    86,    87,    87,    87,
      88,    89,    89,    90,    90,    90,    91,    92,    91,    93,
      93,    94,    94,    94,    94,    94,    95,    95,    95,    95,
      96,    97,    98,    98,    98,    98,    98,    98,    99,   100,
     101,   102,   102,   103,   103,   103,   103,   103,   104,   105,
     106,   106,   108,   109,   107,   110,   111,   107,   112,   107,
     114,   113,   113,   115,   115,   115,   115,   115,   115,   116,
     117,   118,   119,   120,   120,   121,   121,   121,   121,   121,
     121,   121,   121,   121,   121,   121,   121,   121,   121,   121,
     121
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     1,     2,     1,     1,     1,     1,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     1,     2,     4,
       0,     2,     2,     2,     2,     2,     2,     3,     2,     2,
       2,     2,     2,     2,     3,     2,     2,     4,     0,     2,
       2,     2,     2,     4,     4,     4,     4,     2,     2,     2,
       2,     3,     2,     1,     0,     2,     2,     0,     2,     2,
       4,     0,     2,     1,     3,     3,     4,     0,     9,     0,
       2,     2,     2,     2,     3,     2,     0,     2,     3,     2,
       1,     1,     0,     2,     3,     3,     4,     2,     1,     2,
       4,     0,     2,     1,     2,     2,     3,     2,     2,     4,
       0,     2,     0,     0,     5,     0,     0,     5,     0,     3,
       0,     5,     3,     2,     1,     4,     3,     2,     1,     1,
       1,     1,     1,     0,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
     123,     0,     0,     1,   122,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   140,     0,     0,   129,
     130,   128,   131,   132,   133,   134,   135,   125,   127,     0,
     126,   136,     0,   137,     0,   138,   139,   124,     9,     5,
       6,     7,     4,     8,     3,    18,    89,    16,    61,    12,
      13,    14,    98,    36,    10,    11,    15,    20,    38,    91,
     100,     0,     0,     0,     0,     0,    63,    17,    60,     0,
      62,     0,     0,     0,     0,     0,     0,     0,     0,    19,
      21,    53,     0,    54,    57,     0,     0,    82,     0,     0,
       0,    37,    39,    93,     0,     0,     0,    90,    92,   102,
     108,    99,   101,     0,     0,    69,    31,    22,    23,    24,
      25,    28,    26,     0,    30,    29,    32,    33,    35,     0,
      48,    40,    41,    42,     0,    47,    49,    50,    52,     0,
      94,    95,    97,     0,     0,     0,     0,    64,    65,     0,
      27,    34,    55,    56,    58,    59,     0,    88,    87,    83,
      51,    96,   103,   106,   119,   121,   109,   114,   118,     0,
      76,     0,     0,    66,    70,    46,    43,    44,    45,    80,
      81,     0,    84,    85,     0,     0,   120,     0,   113,     0,
     117,    72,    71,    73,    75,     0,    67,    86,   104,   107,
     116,     0,     0,    77,    79,     0,    74,     0,   115,     0,
     112,    78,    69,     0,     0,   111,    68
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short yydefgoto[] =
{
      -1,     1,    19,    43,    20,    21,    22,    23,    24,    25,
      26,    48,    68,    27,    28,    62,    80,    29,    30,    63,
      92,   121,   122,    31,    61,    69,    70,   197,   139,   164,
     182,   172,   173,   125,   149,    32,    33,    64,    98,    34,
      35,    65,   102,   134,   174,   135,   175,   136,   178,   191,
     156,   157,   179,   158,    36,     2,    37
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -157
static const short yypact[] =
{
    -157,    24,    13,  -157,  -157,    33,    98,    -2,    30,    37,
      64,    40,    78,    39,    72,    75,  -157,    89,    70,  -157,
    -157,  -157,  -157,  -157,  -157,  -157,  -157,    64,  -157,    64,
    -157,  -157,    64,  -157,    64,  -157,  -157,  -157,  -157,  -157,
    -157,  -157,  -157,  -157,  -157,  -157,  -157,  -157,  -157,  -157,
    -157,  -157,  -157,  -157,  -157,  -157,  -157,  -157,  -157,  -157,
    -157,    35,    43,    56,    26,    51,    68,  -157,  -157,    64,
    -157,   102,    -7,     8,   -10,    17,   114,   115,     6,  -157,
    -157,  -157,   116,  -157,  -157,   117,    88,  -157,   120,   121,
       9,  -157,  -157,  -157,   122,   123,    11,  -157,  -157,   124,
    -157,  -157,  -157,   125,   126,  -157,  -157,  -157,  -157,  -157,
    -157,  -157,  -157,   127,  -157,  -157,  -157,  -157,  -157,   129,
    -157,     1,     4,  -157,    94,    15,  -157,  -157,  -157,   130,
    -157,  -157,  -157,   131,   132,   133,   100,  -157,  -157,    45,
    -157,  -157,  -157,  -157,  -157,  -157,    67,  -157,  -157,     0,
    -157,  -157,  -157,  -157,  -157,  -157,  -157,   -16,   134,   135,
    -157,   136,    14,    90,  -157,  -157,  -157,  -157,  -157,  -157,
    -157,   128,  -157,  -157,   134,   134,  -157,   137,   139,    83,
     139,  -157,    -8,  -157,  -157,   138,  -157,  -157,   139,   139,
     134,   134,   134,  -157,  -157,   140,  -157,    64,   139,    91,
    -157,  -157,  -157,   134,    45,  -157,  -157
};

/* YYPGOTO[NTERM-NUM].  */
static const short yypgoto[] =
{
    -157,  -157,  -157,  -157,  -157,  -157,  -157,  -157,  -157,  -157,
    -157,   -27,   -54,  -157,  -157,  -157,  -157,  -157,  -157,  -157,
    -157,  -157,  -157,  -157,  -157,  -157,  -157,  -157,   -49,  -157,
    -157,  -157,  -157,  -157,   -17,  -157,  -157,  -157,  -157,  -157,
    -157,  -157,  -157,  -157,  -157,  -157,  -157,  -157,   -60,  -157,
    -157,   -22,  -156,  -157,  -157,  -157,  -157
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, parse error.  */
#define YYTABLE_NINF -111
static const short yytable[] =
{
      57,   111,    58,   193,   107,    59,   176,    60,    79,    91,
      97,   101,   142,    -2,     4,   144,     5,   118,     6,   109,
     128,   114,   132,     7,     3,   184,   169,   170,   115,     8,
       9,    10,    11,    12,    13,   199,   200,    38,    14,    44,
      67,    45,   105,    15,   147,   177,    66,   205,    46,    67,
      52,   112,   113,    16,   108,   194,   195,    67,    17,    67,
      71,   171,   159,   119,   143,    67,   129,   145,   133,   110,
      67,   185,    93,    18,    72,    73,    74,    47,   148,    94,
      95,    49,    96,    53,    81,   163,    54,    75,   160,   161,
      82,    83,    84,    85,    86,    87,    76,    77,   180,    78,
      55,   162,    99,   100,    39,    40,    41,    42,   165,    88,
      89,    56,    90,   106,   188,   189,   166,   167,   168,    50,
      51,   103,   104,   154,   155,   116,   117,   120,   123,   124,
     198,   126,   127,   130,   131,   146,   137,   138,   140,  -105,
     141,   150,   151,   152,   192,   186,   181,   183,   153,   196,
     206,   201,   203,   204,   187,   190,   176,   147,     0,     0,
     154,  -110,     0,     0,     0,     0,     0,     0,     0,     0,
     202
};

static const short yycheck[] =
{
      27,    11,    29,    11,    11,    32,    22,    34,    62,    63,
      64,    65,    11,     0,     1,    11,     3,    11,     5,    11,
      11,     4,    11,    10,     0,    11,    26,    27,    11,    16,
      17,    18,    19,    20,    21,   191,   192,     4,    25,    41,
      14,    11,    69,    30,    29,    61,    11,   203,    11,    14,
      11,    61,    62,    40,    61,    63,    64,    14,    45,    14,
      17,    61,    17,    57,    63,    14,    57,    63,    57,    61,
      14,    57,    46,    60,    31,    32,    33,    13,    63,    53,
      54,    41,    56,    11,    28,   139,    11,    44,    43,    44,
      34,    35,    36,    37,    38,    39,    53,    54,   158,    56,
      11,    56,    51,    52,     6,     7,     8,     9,    41,    53,
      54,    41,    56,    11,   174,   175,    49,    50,    51,    41,
      42,    53,    54,    23,    24,    11,    11,    11,    11,    41,
     190,    11,    11,    11,    11,    41,    11,    11,    11,    15,
      11,    11,    11,    11,    61,    55,    11,    11,    15,    11,
     204,    11,    61,   202,   171,   177,    22,    29,    -1,    -1,
      23,    22,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     197
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,    66,   120,     0,     1,     3,     5,    10,    16,    17,
      18,    19,    20,    21,    25,    30,    40,    45,    60,    67,
      69,    70,    71,    72,    73,    74,    75,    78,    79,    82,
      83,    88,   100,   101,   104,   105,   119,   121,     4,     6,
       7,     8,     9,    68,    41,    11,    11,    13,    76,    41,
      41,    42,    11,    11,    11,    11,    41,    76,    76,    76,
      76,    89,    80,    84,   102,   106,    11,    14,    77,    90,
      91,    17,    31,    32,    33,    44,    53,    54,    56,    77,
      81,    28,    34,    35,    36,    37,    38,    39,    53,    54,
      56,    77,    85,    46,    53,    54,    56,    77,   103,    51,
      52,    77,   107,    53,    54,    76,    11,    11,    61,    11,
      61,    11,    61,    62,     4,    11,    11,    11,    11,    57,
      11,    86,    87,    11,    41,    98,    11,    11,    11,    57,
      11,    11,    11,    57,   108,   110,   112,    11,    11,    93,
      11,    11,    11,    63,    11,    63,    41,    29,    63,    99,
      11,    11,    11,    15,    23,    24,   115,   116,   118,    17,
      43,    44,    56,    77,    94,    41,    49,    50,    51,    26,
      27,    61,    96,    97,   109,   111,    22,    61,   113,   117,
     113,    11,    95,    11,    11,    57,    55,    99,   113,   113,
     116,   114,    61,    11,    63,    64,    11,    92,   113,   117,
     117,    11,    76,    61,    93,   117,    77
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrlab1

/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)           \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#define YYLEX	yylex ()

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)
# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)
/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*-----------------------------.
| Print this symbol on YYOUT.  |
`-----------------------------*/

static void
#if defined (__STDC__) || defined (__cplusplus)
yysymprint (FILE* yyout, int yytype, YYSTYPE yyvalue)
#else
yysymprint (yyout, yytype, yyvalue)
    FILE* yyout;
    int yytype;
    YYSTYPE yyvalue;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvalue;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyout, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyout, yytoknum[yytype], yyvalue);
# endif
    }
  else
    YYFPRINTF (yyout, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyout, ")");
}
#endif /* YYDEBUG. */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
#if defined (__STDC__) || defined (__cplusplus)
yydestruct (int yytype, YYSTYPE yyvalue)
#else
yydestruct (yytype, yyvalue)
    int yytype;
    YYSTYPE yyvalue;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvalue;

  switch (yytype)
    {
      default:
        break;
    }
}



/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
int yyparse (void *);
# else
int yyparse (void);
# endif
#endif


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of parse errors so far.  */
int yynerrs;


int
yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yychar1 = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with.  */

  if (yychar <= 0)		/* This means end of input.  */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more.  */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yychar1 = YYTRANSLATE (yychar);

      /* We have to keep this `#if YYDEBUG', since we use variables
	 which are defined only if `YYDEBUG' is set.  */
      YYDPRINTF ((stderr, "Next token is "));
      YYDSYMPRINT ((stderr, yychar1, yylval));
      YYDPRINTF ((stderr, "\n"));
    }

  /* If the proper action on seeing token YYCHAR1 is to reduce or to
     detect an error, take that action.  */
  yyn += yychar1;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yychar1)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ",
	      yychar, yytname[yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];



#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (yydebug)
    {
      int yyi;

      YYFPRINTF (stderr, "Reducing via rule %d (line %d), ",
		 yyn - 1, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (yyi = yyprhs[yyn]; yyrhs[yyi] >= 0; yyi++)
	YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
      YYFPRINTF (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif
  switch (yyn)
    {
        case 3:
#line 139 "sg.y"
    { httpsConnectionCacheSize = atoi(yyvsp[0].string); }
    break;

  case 4:
#line 143 "sg.y"
    { yyval.integer = UFDB_API_HTTPS_CHECK_OFF; }
    break;

  case 5:
#line 144 "sg.y"
    { yyval.integer = UFDB_API_HTTPS_CHECK_QUEUE_CHECKS; }
    break;

  case 6:
#line 145 "sg.y"
    { yyval.integer = UFDB_API_HTTPS_CHECK_AGRESSIVE; }
    break;

  case 7:
#line 146 "sg.y"
    { yyval.integer = UFDB_API_HTTPS_LOG_ONLY; }
    break;

  case 8:
#line 150 "sg.y"
    { UFDBsetTunnelCheckMethod( yyvsp[0].integer ); }
    break;

  case 9:
#line 153 "sg.y"
    { sgSetting("administrator",yyvsp[0].string); }
    break;

  case 10:
#line 156 "sg.y"
    { sgSetting("dbhome",yyvsp[0].string); }
    break;

  case 11:
#line 159 "sg.y"
    { sgSetting("logdir",yyvsp[0].string); }
    break;

  case 12:
#line 162 "sg.y"
    { sgSetting("port",yyvsp[0].string); }
    break;

  case 13:
#line 165 "sg.y"
    { ufdbSetCPU( yyvsp[0].string ); }
    break;

  case 14:
#line 166 "sg.y"
    { ufdbSetCPU( yyvsp[0].string ); }
    break;

  case 15:
#line 171 "sg.y"
    { analyseUncategorised = atoi( yyvsp[0].string );   }
    break;

  case 18:
#line 181 "sg.y"
    { sgDest(yyvsp[0].string); }
    break;

  case 19:
#line 185 "sg.y"
    { sgDestEnd(); }
    break;

  case 22:
#line 193 "sg.y"
    { sgDestDomainList(yyvsp[0].string); }
    break;

  case 23:
#line 194 "sg.y"
    { sgDestDomainList(NULL); }
    break;

  case 24:
#line 195 "sg.y"
    { sgDestUrlList(yyvsp[0].string); }
    break;

  case 25:
#line 196 "sg.y"
    { sgDestUrlList(NULL); }
    break;

  case 26:
#line 197 "sg.y"
    { sgDestExpressionList(NULL,NULL); }
    break;

  case 27:
#line 198 "sg.y"
    { sgDestExpressionList(yyvsp[0].string,"i"); }
    break;

  case 28:
#line 199 "sg.y"
    { sgDestExpressionList(yyvsp[0].string,"n"); }
    break;

  case 29:
#line 200 "sg.y"
    { sgDestRedirect(yyvsp[0].string); }
    break;

  case 30:
#line 201 "sg.y"
    { sgDestRedirect(yyvsp[0].string); }
    break;

  case 31:
#line 202 "sg.y"
    { sgDestRewrite(yyvsp[0].string); }
    break;

  case 32:
#line 203 "sg.y"
    { sgDestTime(yyvsp[0].string,WITHIN); }
    break;

  case 33:
#line 204 "sg.y"
    { sgDestTime(yyvsp[0].string,OUTSIDE); }
    break;

  case 34:
#line 205 "sg.y"
    { ufdbLog( NULL, "unsupported logfile context for %s", yyvsp[0].string ); }
    break;

  case 35:
#line 206 "sg.y"
    { ufdbLog( NULL, "unsupported logfile context for %s", yyvsp[0].string ); }
    break;

  case 36:
#line 209 "sg.y"
    { sgSource(yyvsp[0].string); }
    break;

  case 37:
#line 212 "sg.y"
    { sgSourceEnd(); }
    break;

  case 42:
#line 221 "sg.y"
    { sgSourceUserList(yyvsp[0].string); }
    break;

  case 43:
#line 222 "sg.y"
    { sgSourceUserQuota(yyvsp[-2].string,yyvsp[-1].string,"3600"); }
    break;

  case 44:
#line 223 "sg.y"
    { sgSourceUserQuota(yyvsp[-2].string,yyvsp[-1].string,"86400"); }
    break;

  case 45:
#line 224 "sg.y"
    { sgSourceUserQuota(yyvsp[-2].string,yyvsp[-1].string,"604800"); }
    break;

  case 46:
#line 225 "sg.y"
    { sgSourceUserQuota(yyvsp[-2].string,yyvsp[-1].string,yyvsp[0].string); }
    break;

  case 48:
#line 227 "sg.y"
    { sgSourceIpList(yyvsp[0].string); }
    break;

  case 49:
#line 228 "sg.y"
    { sgSourceTime(yyvsp[0].string,WITHIN); }
    break;

  case 50:
#line 229 "sg.y"
    { sgSourceTime(yyvsp[0].string,OUTSIDE); }
    break;

  case 51:
#line 230 "sg.y"
    { ufdbLog( NULL, "unsupported logfile context for %s", yyvsp[0].string ); }
    break;

  case 52:
#line 231 "sg.y"
    { ufdbLog( NULL, "unsupported logfile context for %s", yyvsp[0].string ); }
    break;

  case 53:
#line 232 "sg.y"
    { lastSource->cont_search = 1; }
    break;

  case 55:
#line 237 "sg.y"
    { sgSourceDomain(yyvsp[0].string); }
    break;

  case 58:
#line 242 "sg.y"
    { sgSourceUser(yyvsp[0].string); }
    break;

  case 63:
#line 253 "sg.y"
    { sgAcl(yyvsp[0].string,NULL,0); }
    break;

  case 64:
#line 254 "sg.y"
    { sgAcl(yyvsp[-2].string,yyvsp[0].string,WITHIN); }
    break;

  case 65:
#line 255 "sg.y"
    { sgAcl(yyvsp[-2].string,yyvsp[0].string,OUTSIDE); }
    break;

  case 67:
#line 260 "sg.y"
    {sgAcl(NULL,NULL,ELSE);}
    break;

  case 71:
#line 268 "sg.y"
    { }
    break;

  case 72:
#line 269 "sg.y"
    { sgAclSetValue("rewrite",yyvsp[0].string,0); }
    break;

  case 73:
#line 270 "sg.y"
    { sgAclSetValue("redirect",yyvsp[0].string,0); }
    break;

  case 74:
#line 271 "sg.y"
    { ufdbLog( NULL, "unsupported logfile context for %s", yyvsp[0].string ); }
    break;

  case 75:
#line 272 "sg.y"
    { ufdbLog( NULL, "unsupported logfile context for %s", yyvsp[0].string ); }
    break;

  case 77:
#line 276 "sg.y"
    { sgAclSetValue("pass",yyvsp[0].string,1); }
    break;

  case 78:
#line 277 "sg.y"
    { sgAclSetValue("pass",yyvsp[0].string,0); }
    break;

  case 80:
#line 281 "sg.y"
    { sgIp(yyvsp[0].string); }
    break;

  case 81:
#line 284 "sg.y"
    { sgIp(yyvsp[0].string); }
    break;

  case 83:
#line 287 "sg.y"
    { sgIp("255.255.255.255"); sgSetIpType(SG_IPTYPE_HOST,NULL,0); }
    break;

  case 84:
#line 288 "sg.y"
    { sgSetIpType(SG_IPTYPE_CIDR,NULL,0); }
    break;

  case 85:
#line 289 "sg.y"
    { sgSetIpType(SG_IPTYPE_CLASS,NULL,0); }
    break;

  case 86:
#line 290 "sg.y"
    { sgSetIpType(SG_IPTYPE_RANGE,NULL,0); }
    break;

  case 88:
#line 294 "sg.y"
    { sgIp(yyvsp[0].string);}
    break;

  case 89:
#line 297 "sg.y"
    { sgRewrite(yyvsp[0].string); }
    break;

  case 93:
#line 307 "sg.y"
    { sgRewriteSubstitute(yyvsp[0].string); }
    break;

  case 94:
#line 308 "sg.y"
    { sgRewriteTime(yyvsp[0].string,WITHIN); }
    break;

  case 95:
#line 309 "sg.y"
    { sgRewriteTime(yyvsp[0].string,OUTSIDE); }
    break;

  case 96:
#line 310 "sg.y"
    { ufdbLog( NULL, "unsupported logfile context for %s", yyvsp[0].string ); }
    break;

  case 97:
#line 311 "sg.y"
    { ufdbLog( NULL, "unsupported logfile context for %s", yyvsp[0].string ); }
    break;

  case 98:
#line 315 "sg.y"
    { sgTime(yyvsp[0].string); }
    break;

  case 102:
#line 325 "sg.y"
    { sgTimeElementInit(); }
    break;

  case 103:
#line 325 "sg.y"
    { sgTimeElementAdd(yyvsp[0].string,T_WEEKLY); }
    break;

  case 105:
#line 326 "sg.y"
    { sgTimeElementInit(); }
    break;

  case 106:
#line 326 "sg.y"
    { sgTimeElementAdd(yyvsp[0].string,T_WEEKDAY); }
    break;

  case 108:
#line 327 "sg.y"
    { sgTimeElementInit(); }
    break;

  case 109:
#line 327 "sg.y"
    { sgTimeElementEnd(); }
    break;

  case 110:
#line 330 "sg.y"
    { sgTimeElementClone(); }
    break;

  case 119:
#line 342 "sg.y"
    { sgTimeElementAdd(yyvsp[0].string,T_DVAL); }
    break;

  case 120:
#line 345 "sg.y"
    { sgTimeElementAdd(yyvsp[0].tval,T_TVAL); }
    break;

  case 121:
#line 348 "sg.y"
    { sgTimeElementAdd(yyvsp[0].string,T_DVALCRON); }
    break;

  case 122:
#line 353 "sg.y"
    {  yyerror( "syntax error" );  }
    break;


    }

/* Line 1016 of /usr/share/bison/yacc.c.  */
#line 1741 "y.tab.c"

  yyvsp -= yylen;
  yyssp -= yylen;


#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("parse error, unexpected ") + 1;
	  yysize += yystrlen (yytname[yytype]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "parse error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("parse error");
    }
  goto yyerrlab1;


/*----------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
yyerrlab1:
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (yychar == YYEOF)
        {
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (yyssp > yyss)
	    {
	      YYDPRINTF ((stderr, "Error: popping "));
	      YYDSYMPRINT ((stderr,
			    yystos[*yyssp],
			    *yyvsp));
	      YYDPRINTF ((stderr, "\n"));
	      yydestruct (yystos[*yyssp], *yyvsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  yychar, yytname[yychar1]));
      yydestruct (yychar1, yylval);
      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDPRINTF ((stderr, "Error: popping "));
      YYDSYMPRINT ((stderr,
		    yystos[*yyssp], *yyvsp));
      YYDPRINTF ((stderr, "\n"));

      yydestruct (yystos[yystate], *yyvsp);
      yyvsp--;
      yystate = *--yyssp;


#if YYDEBUG
      if (yydebug)
	{
	  short *yyssp1 = yyss - 1;
	  YYFPRINTF (stderr, "Error: state stack now");
	  while (yyssp1 != yyssp)
	    YYFPRINTF (stderr, " %d", *++yyssp1);
	  YYFPRINTF (stderr, "\n");
	}
#endif
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 379 "sg.y"


void sgReadConfig( char * file )
{
  char *      text;
  char *      defaultFile = DEFAULT_CONFIGFILE;
  extern int  analyseUncategorised;

  lineno = 1;
  ufdbResetCPUs();

  configFile = file;
  if (configFile == NULL)
    configFile = defaultFile;

  yyin = fopen(configFile,"r");
  if (yyin == NULL) 
  {
    ufdbLogFatalError( "%s: can't open configuration file %s", progname, configFile );
    return;
  }

  ufdbLogError( "configuration file: %s", configFile );

  (void) yyparse();
  fclose( yyin );

  /*
   * For analysis of uncategorised URLs we also load a "known" database
   * that contains URLs that are reviewed and known.
   */
  if (analyseUncategorised)
  {
     char * dbhome;
     char   dbfname[1024];

     dbhome = sgSettingGetValue("dbhome");
     if (dbhome == NULL)
       dbhome = DEFAULT_DBHOME;
     sprintf( dbfname, "%s/checked/domains.ufdb", dbhome );
     if (UFDBloadDatabase( &knownDb, dbfname ) != UFDB_API_OK)
     {
        knownDb.table.nNextLevels = 0;
	analyseUncategorised = 0;
        ufdbLogError( "uncategorised URLs will NOT be analysed since there is no proper database" );
     }
     else
        ufdbLogError( "a sample of uncategorised URLs will be analysed." );
  }

  switch (httpsChecks)
  {
     case UFDB_API_HTTPS_CHECK_OFF:   		text = "off";  break;
     case UFDB_API_HTTPS_CHECK_QUEUE_CHECKS:   	text = "queue-checks";  break;
     case UFDB_API_HTTPS_CHECK_AGRESSIVE:   	text = "agressive";  break;
     case UFDB_API_HTTPS_LOG_ONLY:   		text = "log-only";  break;
     default:  					text = "unknown";   break;
  }
  ufdbLogError( "proxy tunnel detection is set to \"%s\"", text );

  if (defaultAcl == NULL)
     ufdbLogFatalError( "%s: default acl not defined in configuration file  %s", progname, configFile );
}


/*
 * Logfile functions
 */

void ufdbLogFile(  
  int     block, 
  int     anonymous, 
  char *  file     )
{
  void ** v;
  char *  name;
  struct LogFile * p;

  switch (block)
  {
  case(SG_BLOCK_DESTINATION):
    v = (void **) &lastDest->logfile;
    name = lastDest->name;
    break;
  case(SG_BLOCK_SOURCE):
    v = (void **) &lastSource->logfile;
    name = lastSource->name;
    break;
  case(SG_BLOCK_REWRITE):
    v = (void **) &lastRewrite->logfile;
    name = lastRewrite->name;
    break;
  case(SG_BLOCK_ACL):
    v = (void **) &lastAcl->logfile;
    name = lastAcl->name;
    if (strcmp(name,"default") != 0) {
      ufdbLogError("logfile not allowed in acl other than default");
    }
    break;
  default:
    return;
  }

  if (*v == NULL)
  {
    p = (struct LogFile *) ufdbMalloc( sizeof(struct LogFile) );
    p->stat = ufdbLogFileStat( file );
    p->parent_name = name;
    p->parent_type = block;
    p->anonymous = anonymous;
    *v = p;
  } else {
    ufdbLogError("%s: redefine of logfile %s in line %d",
		    progname,file,lineno);
    return;
  }
}


/* Multiple logfile= statements may have the same logfile name !
 * So we must open the file once and use copies of the fp struct.
 */
struct LogFileStat * ufdbLogFileStat(  
  char *      file )
{
  struct LogFileStat * sg;
  FILE *      fd;
  struct stat s;
  char        buf[MAX_BUF];

  if (*file == '/')
     strcpy( buf, file );
  else
  {
    if (globalLogDir == NULL)
      strcpy( buf, DEFAULT_LOGDIR );
    else
      strcpy( buf, globalLogDir );
    strcat( buf, "/" );
    strcat( buf, file );
  }

#ifdef UFDB_ROTATE_LOG_FILES
  /* rotate log file if it is larger than UFDB_MAX_INITIAL_LOGFILE_SIZE */
  if (stat(buf,&s) == 0) 
  {
     if (s.st_size > UFDB_MAX_INITIAL_LOGFILE_SIZE)
       sgRotateLogfile( buf );
  }
#endif

  if ((fd = fopen(buf, "a")) == NULL) {
    ufdbLogError("%s: can't write to logfile %s",progname,buf);
    return NULL;
  }
  if (stat(buf,&s) != 0) {
    ufdbLogError("%s: can't stat logfile %s",progname,buf);
    return NULL;
  }

  if (LogFileStat == NULL)
  {
    sg = (struct LogFileStat *) ufdbMalloc( sizeof(struct LogFileStat) );
    sg->name = ufdbMalloc( strlen(buf) + 1 );
    strcpy( sg->name, buf );
    sg->st_ino = s.st_ino;
    sg->st_dev = s.st_dev;
    sg->fd = fd;
    sg->next = NULL;
    LogFileStat = sg;
    lastLogFileStat = sg;
  }
  else 
  {
    for (sg = LogFileStat; sg != NULL; sg = sg->next)
    {
      if (sg->st_ino == s.st_ino && sg->st_dev == s.st_dev)
      {
	fclose(fd);
	return sg;
      }
    }
    sg = (struct LogFileStat *) ufdbMalloc( sizeof(struct LogFileStat) );
    sg->name = ufdbMalloc( strlen(buf) + 1 );
    strcpy( sg->name, buf );
    sg->st_ino = s.st_ino;
    sg->st_dev = s.st_dev;
    sg->fd = fd;
    sg->next = NULL;
    lastLogFileStat->next = sg;
    lastLogFileStat = sg;
  }

  return lastLogFileStat;
}


void sgReopenLogfile( char * filename )
{
   struct LogFileStat * sg;

#if 0
   fprintf( stderr, "sgReopenLogfile %s\n", filename );
#endif

#ifdef UFDB_ROTATE_LOG_FILES
   for (sg = LogFileStat; sg != NULL; sg = sg->next)
   {
      if (strcmp( sg->name, filename ) == 0)
      {
         fclose( sg->fd );
	 sgRotateLogfile( sg->name ); 
	 sg->fd = fopen( sg->name, "a" );
	 return;
      }
   }
#endif
}


/*
 * Source functions
 */

void sgSource( char * source )
{
  struct Source * sp;

  if (Source != NULL)  
  {
    if ((struct Source *) sgSourceFindName(source) != NULL)
    {
      ufdbLogFatalError( "%s: source %s is defined in configuration file %s",
		       progname, source, configFile );
      return;
    }
  }

  sp = (struct Source *) ufdbMalloc( sizeof(struct Source) );
  sp->name = (char *) ufdbMalloc( strlen(source)+1 );
  strcpy( sp->name, source );
  sp->active = 1;
  sp->ip = NULL;
  sp->lastip = NULL;
  sp->domainDb = NULL;
  sp->userDb = NULL;
  sp->time = NULL;
  sp->within = 0;
  sp->cont_search = 0;
  sp->logfile = NULL;
  sp->next = NULL;
  sp->userquota.seconds = 0;
  sp->userquota.renew = 0;
  sp->userquota.sporadic = 0;

  if (Source == NULL) {
    Source = sp;
    lastSource = sp;
  } else {
    lastSource->next = sp;
    lastSource = sp;
  }
}


void sgSourceEnd( void )
{
  struct Source * s;

  s = lastSource;
  if (s->ip == NULL && s->domainDb == NULL && s->userDb == NULL)
  {
    ufdbLogError( "sourceblock %s missing active content, set inactive", s->name );
    s->time = NULL;
    s->active = 0;
  }
}


void sgSourceUser( char * user )
{
  struct Source * sp;
  char * lc;
  struct UserQuotaInfo q;

  sp = lastSource;
  if (sp->userDb == NULL)
    sp->userDb = (void *) UFDBmemDBinit();

  for (lc = user; *lc != '\0'; lc++)    /* convert username to lowercase chars */
  {
    if (*lc >= 'A'  &&  *lc <= 'Z')
       *lc += 'a' - 'A';
  }

  UFDBmemDBinsert( (struct UFDBmemDB *) sp->userDb, user, (char *) setuserquota(&q),
	           sizeof(struct UserQuotaInfo) );
}


void sgSourceUserList( 
  char * file  )
{
  char * dbhome, *f;
  FILE * fp;
  char * p, *c, *s, *lc;
  char * lineptr;
  struct Source * sp;
  struct UserQuotaInfo q;
  char   line[MAX_BUF];

  sp = lastSource;
  if (sp->userDb == NULL) 
    sp->userDb = (void *) UFDBmemDBinit();
 
  dbhome = sgSettingGetValue("dbhome");
  if (dbhome == NULL)
    dbhome = DEFAULT_DBHOME;

  if (file[0] == '/')
    f = ufdbStrdup( file );
  else
  {
    f = (char *) ufdbMalloc( strlen(dbhome) + strlen(file) + 2 );
    strcpy(f,dbhome);
    strcat(f,"/");
    strcat(f,file);
  }

  if ((fp = fopen(f,"r")) == NULL)
  {
    ufdbLogError("%s: can't open userlist %s: %s", progname, f, strerror(errno) );
    ufdbFree( f );
    return;
  }

  while (fgets(line,sizeof(line),fp) != NULL)
  {
    if (line[0] == '#')			/* skip comments */
      continue;

    p = strchr(line,'\n');
    if (p != NULL && p != line) 
    {
      if (*(p - 1) == '\r') 		/* remove ^M  */
	p--;
      *p = '\0';
    }

    c = strchr( line, '#' );		/* remove comment */
    if (c != NULL)
       *c = '\0';

    p = strtok_r( line, " \t,", &lineptr );
    if ((s = strchr(line,':')) != NULL) 
    {
      *s = '\0';
      for (lc = line; *lc != '\0'; lc++)  /* convert username to lowercase chars */
      {
	if (*lc >= 'A'  &&  *lc <= 'Z')
	   *lc += 'a' - 'A';
      }
      UFDBmemDBinsert( (struct UFDBmemDB *) sp->userDb, line, (char *) setuserquota(&q),
                       sizeof(struct UserQuotaInfo));
    }
    else 
    {
      do {
	for (lc=p; *lc != '\0'; lc++)   /* convert username to lowercase chars */
        {
	  if (*lc >= 'A'  &&  *lc <= 'Z')
	     *lc += 'a' - 'A';
        }
        UFDBmemDBinsert( (struct UFDBmemDB *) sp->userDb, p, (char *) setuserquota(&q),
	                 sizeof(struct UserQuotaInfo));
      } while ((p = strtok_r(NULL," \t,",&lineptr)) != NULL);
    }
  }

  fclose( fp );
  ufdbFree( f );
}


void sgSourceUserQuota( char * seconds, char * sporadic, char * renew )
{
  int s;
  struct UserQuota * uq;
  struct Source * sp;

  sp = lastSource;
  uq = &sp->userquota;
  s = atoi(seconds);
  if (s <= 0)
    ufdbLogError("Userquota seconds sporadic hourly|daily|weekly");
  uq->seconds = s; 
  s = atoi(sporadic);
  if (s <= 0)
    ufdbLogError("Userquota seconds sporadic hourly|daily|weekly");
  uq->sporadic = s; 
  s = atoi(renew);
  if (s <= 0)
    ufdbLogError("Userquota seconds sporadic hourly|daily|weekly");
  uq->renew = s;
}


void sgSourceDomain( char * domain )
{
  struct Source * sp;

  sp = lastSource;
  if (sp->domainDb == NULL) 
    sp->domainDb = (struct sgDb *) UFDBmemDBinit();
  UFDBmemDBinsert( (struct UFDBmemDB *) sp->domainDb, domain, NULL, 0 );
}


void sgSourceTime( char * name, int within )
{
  struct Time *   time = NULL;
  struct Source * sp;

  sp = lastSource;
  if ((time = sgTimeFindName(name)) == NULL)
  {
    ufdbLogFatalError( "%s: Time %s is not defined in configuration file %s",
		     progname, name, configFile );
    return;
  }
  sp->within = within;
  sp->time = time;
}


struct Source * sgSourceFindName( char * name )
{
  struct Source *p;

  for (p=Source; p != NULL; p = p->next)
  {
    if (strcmp(name,p->name) == 0)
      return p;
  }
  return NULL;
}


void sgSourceIpList( char * file )
{
  char * dbhome = NULL, *f;
  FILE * fd;
  char * p,*c,*cidr;
  int    i, l=0;
  char * lineptr;
  char   line[MAX_BUF];

  dbhome = sgSettingGetValue("dbhome");
  if (dbhome == NULL)
    dbhome = DEFAULT_DBHOME;

  if (file[0] == '/') {
    f = ufdbStrdup(file);
  } else {
    f = (char *) ufdbMalloc( strlen(dbhome) + strlen(file) + 2 );
    strcpy(f,dbhome);
    strcat(f,"/");
    strcat(f,file);
  }
  if ((fd = fopen(f,"r")) == NULL) {
    ufdbLogError("%s: can't open iplist %s: %s",progname, f,strerror(errno));
    return;
  }
  ufdbLogError("init iplist %s",f);
  while (fgets(line,sizeof(line),fd) != NULL)
  {
    l++;
    if (*line == '#')
      continue;
    p = strchr(line,'\n');
    if (p != NULL && p != line) {
      if (*(p - 1) == '\r') /* removing ^M  */
	p--;
      *p = '\0';
    }
    c = strchr(line,'#');
    p = strtok_r( line, " \t,", &lineptr );
    do {
      if (c != NULL && p >= c) /*find the comment */
	break;
      i=strspn(p,".0123456789/-");
      if (i == 0)
	break;
      *(p + i ) = '\0';
      if ((cidr = strchr(p,'/')) != NULL) {
	*cidr = '\0';
	cidr++;
	sgIp(p);
	sgIp(cidr);
	if (strchr(cidr,'.') == NULL)
	  sgSetIpType(SG_IPTYPE_CIDR,f,l);
	else 
	  sgSetIpType(SG_IPTYPE_CLASS,f,l);
      } else if ((cidr = strchr(p,'-')) != NULL) {
	*cidr = '\0';
	cidr++;
	sgIp(p);
	sgIp(cidr);
	sgSetIpType(SG_IPTYPE_RANGE,f,l);
      } else {
	sgIp(p);
	sgIp(ufdbStrdup("255.255.255.255"));
	sgSetIpType(SG_IPTYPE_HOST,f,l);
      }
    } while ((p=strtok_r(NULL," \t,",&lineptr)) != NULL);
  }

  fclose(fd);
}


/*
 *  called by main loop: find a source definition based on the user ident/domain/ip
 */
struct Source * sgFindSource( 
  struct Source *    allSrcs, 
  char *             net, 
  struct SquidInfo * si )
{
  struct Source *    s;
  struct Ip *        ip;
  int                foundip, founduser, founddomain, unblockeduser;
  unsigned long      i, octet, op;

#ifdef UFDB_USERQUOTA_SUPPORT
  struct UserQuotaInfo * q = NULL;
#endif

#if 0
  ufdbLogError( "  sgFindSource( %s, %s, ... )", allSrcs->name, net );
#endif

  octet = 0;
  if (net != NULL)
  {
    if (sgConvDot(net,&op) != NULL)
      octet = op;
  }

  for (s = allSrcs; s != NULL; s = s->next)
  {
    if (s->active == 0)
      continue;

    foundip = founduser = founddomain = 0;
    unblockeduser = 1;

    if (s->ip != NULL)
    {
      if (net == NULL)
	foundip = 0;
      else 
      {
	for (ip = s->ip; ip != NULL; ip = ip->next)
	{
	  if (ip->net_is_set == 0)
	    continue;

	  if (ip->type == SG_IPTYPE_RANGE) 
	  {
	    if (octet >= ip->net && octet <= ip->mask) {
	      foundip = 1;
	      break;
	    }
	  }
	  else				/* CIDR or HOST */
	  { 
	    i = octet & ip->mask;
	    if (i == ip->net) {
	      foundip = 1;
	      break;
	    }
	  }
	}
      }
    }
    else
      foundip = 1;

    if (s->userDb != NULL)
    {
      if (si->ident[0] == '\0')
	founduser = 0;
      else 
      {
#ifdef UFDB_USERQUOTA_SUPPORT
	/* see if the user has a quota definition */
	if (UFDBmemDBfind( (struct UFDBmemDB *) s->userDb, si->ident, (char **) (char *) &q ) == 1)
	{
	  founduser = 1;
	  unblockeduser = 1;
	  if (s->userquota.seconds != 0) 
	  {
	    time_t t = time(NULL) + globalDebugTimeDelta;
#if 0
	    ufdbLogError( "status %d time %d lasttime %d consumed %d", 
	                  q->status, q->time, q->last, q->consumed );
	    ufdbLogError( "renew %d seconds %d", s->userquota.renew, s->userquota.seconds );
#endif
	    if (q->status == 0)   /* first time */
	    {
	      q->status = 1;
	      q->time = t;
	      q->last = t;
	      /* ufdbLogError("user %s first time %d", si->ident, q->time); */
	    }
	    else if (q->status == 1) 
	    {
	      /* ufdbLogError("user %s other time %d %d", si->ident, q->time, t ); */
	      if (s->userquota.sporadic > 0) 
	      {
		if (t - q->last  < s->userquota.sporadic) {
		  q->consumed += t - q->last;
		  q->time = t;
		}
		if (q->consumed > s->userquota.seconds) {
		  q->status = 2; /* block this user, time is up */
		  unblockeduser = 0;
		}
		q->last = t;
		/* ufdbLogError( "user %s consumed %d %d", si->ident, q->consumed, q->last ); */
	      }
	      else if (q->time + s->userquota.seconds < t) 
	      {
		ufdbLogError( "time is up user %s blocket", si->ident);
		q->status = 2; /* block this user, time is up */
		unblockeduser = 0;
	      } 
	    }
	    else
	    {
	      ufdbLogError( "user %s blocked %d %d %d %d", 
	         si->ident, q->status, 
		 q->time, t, (q->time + s->userquota.renew) - t);
	      if (q->time + s->userquota.renew < t)  /* new chance */
	      {
		/* ufdbLogError( "user %s new chance", si->ident ); */
		unblockeduser = 1;
		q->status = 1;
		q->time = t;
		q->consumed = 0;
	      }
	      else 
		unblockeduser = 0;
	    }
	    UFDBmemDBinsert( (struct UFDBmemDB *) s->userDb, si->ident, (char *) q,
		             sizeof(struct UserQuotaInfo) );
	  }
	}
#endif  /* UFDB_USERQUOTA_SUPPORT */
      }
    }
    else
      founduser = 1;

    if (s->domainDb != NULL)
    {
      if (si->srcDomain[0] == '\0')
	founddomain = 0;
      else 
      {
	if (UFDBmemDBfind( (struct UFDBmemDB *) s->domainDb, si->srcDomain, (char **) NULL) == 1)
	  founddomain = 1;
      }
    }
    else
      founddomain = 1;

    if (founduser && foundip && founddomain)
    {
      if (unblockeduser)
	return s;
      else 
      {
	si->lastActiveSource = s;
	return NULL;
      }
    }
  }

  return NULL;
}


/* destination block funtions */

void sgDest( char * dest )
{
  struct Destination * sp;

  if (Dest != NULL) 
  {
    if ((struct Destination *) sgDestFindName(dest) != NULL)
    {
      ufdbLogFatalError( "%s: destination %s is defined in configuration file %s",
		       progname, dest, configFile );
      return;
    }
  }

  sp = (struct Destination *) ufdbMalloc( sizeof(struct Destination) );
  sp->name = (char  *) ufdbMalloc( strlen(dest) + 1 );
  strcpy( sp->name, dest );
  sp->active = 1;
  sp->domainlist = NULL;
  sp->domainlistDb = NULL;
  sp->expressionlist = NULL;
  sp->regExp = NULL;
  sp->rewrite = NULL;
  sp->redirect = NULL;
  sp->time = NULL;
  sp->within = 0;
  sp->logfile = NULL;
  sp->next = NULL;

  if (Dest == NULL) {
    Dest = sp;
    lastDest = sp;
  } else {
    lastDest->next = sp;
    lastDest = sp;
  }
}


void sgDestEnd( void )
{
  struct Destination * d;
 
  d = lastDest;
  if (d->domainlist == NULL && d->expressionlist == NULL
      && d->redirect == NULL && d->rewrite == NULL)
  {
    ufdbLogError( "dest block \"%s\" is missing content, set inactive", d->name );
    d->time = NULL;
    d->active = 0;
  }
}


void sgDestDomainList( char * domainlist )
{
  struct Destination * sp;
  char * dbhome = NULL;
  char * dl = domainlist;
  char * name;

  dbhome = sgSettingGetValue("dbhome");
  sp = lastDest;
  if (dbhome == NULL)
    dbhome = DEFAULT_DBHOME;

  if (domainlist == NULL)
  {
    name = sp->name;
    dl = (char *) ufdbMalloc( sizeof("/dest/") + strlen(name) + sizeof("/domainlist") + 2 );
    strcpy(dl,"/dest/");
    strcat(dl,name);
    strcat(dl,"/domainlist");

    sp->domainlist = (char *) ufdbMalloc( strlen(dbhome) + strlen(dl) + 2 );
    strcpy(sp->domainlist,dbhome);
    strcat(sp->domainlist,"/");
    strcat(sp->domainlist,dl);
  }
  else
  {
    if (domainlist[0] == '/') 
      sp->domainlist = ufdbStrdup( domainlist );
    else
    {
       sp->domainlist = (char *) ufdbMalloc( strlen(dbhome) + strlen(domainlist) + 2 );
       strcpy( sp->domainlist, dbhome );
       strcat( sp->domainlist, "/" );
       strcat( sp->domainlist, domainlist );
    }
  }

  sp->domainlistDb = (struct sgDb *) ufdbCalloc( 1, sizeof(struct sgDb) );
  sp->domainlistDb->type = SGDBTYPE_DOMAINLIST;
  sgDbInit( sp->domainlistDb, sp->domainlist );
  ufdbLogError( "init domainlist %s", sp->domainlist );
  if (sp->domainlistDb->entries == 0)  /* empty database */
  {
    ufdbLogError( "domainlist empty, removed from memory" );
    ufdbFree( sp->domainlistDb );
    sp->domainlistDb = NULL;
  }
}


void ufdbFreeDomainDb( struct sgDb * dbp )
{
   struct UFDBmemTable * mt;

   if (dbp == NULL)
      return;

   mt = (struct UFDBmemTable *) dbp->dbcp;
   UFDBfreeTableIndex( &(mt->table) ); 		/*.nextLevel[0]) ); */
   ufdbFree( (void *) mt->mem );
   ufdbFree( mt );
   ufdbFree( dbp );
}


void ufdbFreeIpList( struct Ip * p )
{
   if (p == NULL)
      return;

   ufdbFreeIpList( p->next );
   if (p->str != NULL)
      ufdbFree( p->str );
   ufdbFree( p );
}


void ufdbFreeSourceList( struct Source * p )
{
   if (p == NULL)
      return;

   ufdbFreeSourceList( p->next );

   ufdbFreeIpList( p->ip );
   ufdbFree( p->name );
   UFDBmemDBdeleteDB( (struct UFDBmemDB *) p->domainDb );
   UFDBmemDBdeleteDB( (struct UFDBmemDB *) p->userDb );

   ufdbFree( p );
}


void ufdbFreeAclDestList( struct AclDest * p )
{
   if (p == NULL)
      return;

   ufdbFreeAclDestList( p->next );
   ufdbFree( p->name );
   ufdbFree( p );
}


void ufdbFreeAclList( struct Acl * p )
{
   if (p == NULL)
      return;

   ufdbFreeAclList( p->next );

   ufdbFree( p->name );
   ufdbFreeAclDestList( p->pass );
   ufdbFree( p->redirect );

   ufdbFree( p );
}


void ufdbFreeSettingList( struct Setting * p )
{
   if (p == NULL)
      return;

   ufdbFreeSettingList( p->next );
   ufdbFree( p->name );
   ufdbFree( p->value );
   ufdbFree( p );
}


void ufdbFreeDestDomainList( struct Destination * p )
{
   if (p == NULL)
      return;

   ufdbFreeDestDomainList( p->next );

   ufdbFree( p->name );
   ufdbFree( p->domainlist );
   ufdbFreeDomainDb( p->domainlistDb );
   ufdbFree( p->expressionlist );
   ufdbFreeRegExprList( p->regExp );
   ufdbFree( p->redirect );
   ufdbFree( p->rewrite );
   ufdbFree( p );
}


void ufdbFreeRewriteList( struct sgRewrite * p )
{
   if (p == NULL)
      return;

   ufdbFreeRegExprList( p->rewrite );
   ufdbFreeRewriteList( p->next );
   ufdbFree( p->name );
   ufdbFree( p );
}


void ufdbFreeTimeElement( struct TimeElement * t )
{
   if (t == NULL)
      return;

   ufdbFreeTimeElement( t->next );
   ufdbFree( t );
}


void ufdbFreeTime( struct Time * t )
{
   if (t == NULL)
      return;

   ufdbFreeTime( t->next );
   ufdbFree( t->name );
   ufdbFreeTimeElement( t->element );
   ufdbFree( t );
}


void ufdbFreeAllMemory( void )
{
   if (globalLogDir != NULL)
      ufdbFree( globalLogDir );
   globalLogDir = NULL;
   /*** globalErrorLog = NULL; ***/
   globalLogFile = NULL;

   ufdbFreeSettingList( Setting );
   ufdbFreeRewriteList( Rewrite );
   ufdbFreeDestDomainList( Dest );
   ufdbFreeAclList( Acl );
   ufdbFreeSourceList( Source );

   /* free knownDb */
   if (knownDb.table.nNextLevels > 0  &&  knownDb.mem != NULL)
   {
      UFDBfreeTableIndex( &(knownDb.table) ); 		/* .nextLevel[0]) ); */
      ufdbFree( (void *) knownDb.mem );
      knownDb.table.nNextLevels = 0;
      knownDb.mem = NULL;
   }

   /* set all pointers back to NULL */

   lastSetting = NULL;
   Setting = NULL;

   lastSource = NULL;
   Source = NULL;
   /*** saveSource = NULL; ***/

   lastDest = NULL;
   Dest = NULL;

   lastRewrite = NULL;
   Rewrite = NULL;
   lastRewriteRegExec = NULL;

   ufdbFreeTime( Time );
   Time = NULL;
   lastTime = NULL;

   ufdbFree( TimeElementsEvents );
   TimeElementsEvents = NULL;

   lastTimeElement = NULL;
   TimeElement = NULL;

   lastAcl = NULL;
   defaultAcl = NULL;
   Acl = NULL;
   lastAclDest = NULL;

   lastRegExpDest = NULL;
}


void sgDestUrlList( char * urllist )
{
   if (urllist == NULL)
      urllist = "-";
   ufdbLogError( "\"urllist %s\" is deprecated and ignored *****", urllist );
}


void sgDestExpressionList( char * exprlist, char * chcase  )
{
  FILE * fp;
  struct Destination * sp;
  struct ufdbRegExp * regexp;
  char * dbhome;
  char * dl;
  char * name, *p;
  int    flags        = REG_EXTENDED | REG_NOSUB;
  char   buf[MAX_BUF];
  char   errbuf[256];

  dbhome = sgSettingGetValue("dbhome");
  sp = lastDest;
  if (dbhome == NULL)
    dbhome = DEFAULT_DBHOME;

  if (exprlist == NULL)
  {
    name = sp->name;
    dl = (char *) ufdbMalloc( sizeof("/dest/") + strlen(name) + sizeof("/expressionlist") + 2 );
    strcpy(dl,"/dest/");
    strcat(dl,name);
    strcat(dl,"/expressionlist");

    flags |= REG_ICASE; 	/* default case insensitive */

    sp->expressionlist = (char *) ufdbMalloc( strlen(dbhome) + strlen(dl) + 2 );
    strcpy(sp->expressionlist,dbhome);
    strcat(sp->expressionlist,"/");
    strcat(sp->expressionlist,dl);
  }
  else
  {
    if (exprlist[0] == '/') {
      sp->expressionlist = ufdbStrdup(exprlist);
    } else {
       sp->expressionlist = (char *) ufdbMalloc( strlen(dbhome) + strlen(exprlist) + 2 );
       strcpy(sp->expressionlist,dbhome);
       strcat(sp->expressionlist,"/");
       strcat(sp->expressionlist,exprlist);
    }
    if (*chcase == 'i')
       flags |= REG_ICASE;     /* set case insensitive */
  }

  ufdbLogError( "init expressionlist %s", sp->expressionlist );
  if ((fp = fopen(sp->expressionlist, "r")) == NULL) 
  {
    ufdbLogFatalError( "expression list %s: %s", sp->expressionlist, strerror(errno) );
    return;
  }

  while (!feof(fp)  &&  fgets(buf, sizeof(buf), fp) != NULL) 
  {
    p = (char *) strchr(buf,'\n');
    if (p != NULL && p != buf) {
      if (*(p-1) == '\r') 	/* removing ^M  */
	p--;
      *p = '\0';
    }
    regexp = ufdbNewPatternBuffer( buf, flags );
    if (regexp->error) 
    {
      regerror( regexp->error, regexp->compiled, errbuf, sizeof(errbuf) );
      ufdbLogError( "%s: %s: %s", sp->expressionlist, strerror(errno), buf );
    }
    if (lastDest->regExp == NULL) 
    {
      lastDest->regExp = regexp;
      lastRegExpDest = regexp;
    }
    else
    {
      lastRegExpDest->next = regexp;
      lastRegExpDest = regexp;
    }
  }

  fclose(fp);
}


void sgDestRedirect( char * value )
{
  struct Destination * sp;

  sp = lastDest;
  sp->redirect = (char *) ufdbMalloc( strlen(value) + 1 );
  strcpy( sp->redirect, value );
}


void sgDestRewrite( char * value )
{
  struct sgRewrite *   rewrite;
  struct Destination * sp;

  sp = lastDest;
  if ((rewrite = sgRewriteFindName(value)) == NULL)
  {
    ufdbLogFatalError( "%s: Rewrite %s is not defined in configuration file %s",
		     progname, value, configFile );
    return;
  }
  sp->rewrite = rewrite;
}



void sgDestTime( char * name, int within )
{
  struct Time * time = NULL;
  struct Destination * sp;

  sp = lastDest;
  if ((time = sgTimeFindName(name)) == NULL) 
  {
    ufdbLogFatalError( "%s: Time %s is not defined in configuration file %s",
		     progname, name, configFile );
    return;
  }
  sp->within = within;
  sp->time = time;
}


struct Destination * sgDestFindName( 
  char *               name )
{
  struct Destination * p;

  for (p = Dest; p != NULL; p = p->next)
  {
    if (strcmp(name,p->name) == 0)
      return p;
  }
  return NULL;
}


/*
 * Setting functions
 */
void sgSetting( char * name, char * value )
{
  struct Setting * sp;

  if (strcmp( name, "port" ) == 0)
  {
     portNum = atoi( value );
     if (portNum <= 0)
     {
        ufdbLogError( "port number must be > 0, using default port." );
	portNum = UFDB_DAEMON_PORT;
     }
     return;
  }

  if (Setting != NULL)
  {
    if ((struct Setting *) sgSettingFindName(name) != NULL)
    {
      ufdbLogFatalError( "%s: setting %s is defined in configuration file %s",
		         progname, name, configFile );
      return;
    }
  }

  sp = (struct Setting *) ufdbMalloc( sizeof(struct Setting) );
  sp->name = ufdbStrdup(name);
  sp->value = ufdbStrdup(value);
  sp->next = NULL;

  if (Setting == NULL) {
    Setting = sp;
    lastSetting = sp;
  } else {
    lastSetting->next = sp;
    lastSetting = sp;
  }

  if (strcmp(name,"logdir") == 0) 
  {
     globalLogDir = ufdbStrdup(value);
     sgSetGlobalErrorLogFile();
  }
}


struct Setting * sgSettingFindName( char * name )
{
  struct Setting * p;

  for (p = Setting; p != NULL; p = p->next)
  {
    if (strcmp(name,p->name) == 0)
      return p;
  }
  return NULL;
}


char * sgSettingGetValue( char * name )
{
  struct Setting * p;

  p = sgSettingFindName(name);
  if (p != NULL)
    return p->value;
  return NULL;
}


/*
 * sgRewrite function
 */

void sgRewrite( char * rewrite )
{
  struct sgRewrite * rew;

  if (Rewrite != NULL)
  {
    if ((struct sgRewrite *) sgRewriteFindName(rewrite) != NULL)
    {
      ufdbLogFatalError( "%s: rewrite %s is defined in configuration file %s",
		       progname, rewrite, configFile );
      return;
    }
  }
  rew = (struct sgRewrite *) ufdbMalloc( sizeof(struct sgRewrite) );
  rew->name = ufdbStrdup(rewrite);
  rew->active = 1;
  rew->rewrite = NULL;
  rew->logfile = NULL;
  rew->time = NULL;
  rew->within = 0;
  rew->next = NULL;

  if (Rewrite == NULL) 
  {
    Rewrite = rew;
    lastRewrite = rew;
  }
  else
  {
    lastRewrite->next = rew;
    lastRewrite = rew;
  }
}


void sgRewriteTime( char * name, int within )
{
  struct Time * time = NULL;
  struct sgRewrite * sp;

  sp = lastRewrite;
  if ((time = sgTimeFindName(name)) == NULL)
  {
    ufdbLogFatalError( "%s: Time %s is not defined in configuration file %s",
		     progname, name, configFile );
    return;
  }
  sp->within = within;
  sp->time = time;
}


void sgRewriteSubstitute( char * string )
{
  char * pattern, 
       * subst = NULL, 
       * p;
  int    flags = REG_EXTENDED;
  int    global = 0;
  char * httpcode = NULL;
  struct ufdbRegExp * regexp;
  char   errbuf[256];

  pattern = string + 2; 	/* skipping s@ */
  p = pattern;
  while ((p = strchr(p,'@')) != NULL)
  {
    if (*( p - 1) != '\\') {
      *p = '\0';
      subst = p + 1;
      break;
    }
    p++;
  }

  p = strrchr(subst,'@');
  while (p != NULL && *p != '\0')
  {
    if (*p == 'r' )
      httpcode =  REDIRECT_TEMPORARILY;
    if (*p == 'R' )
      httpcode =  REDIRECT_PERMANENT;
    if (*p == 'i' || *p == 'I')
      flags |= REG_ICASE;
    if (*p == 'g')
      global = 1;
    *p = '\0'; 		/* removes @i from string */
    p++;
  } 
  regexp = ufdbNewPatternBuffer(pattern,flags);
  if (regexp->error) 
  {
      regerror(regexp->error,regexp->compiled, errbuf,sizeof(errbuf));
      ufdbLogError("Error in regexp %s: %s",pattern,errbuf);
  }
  else {
    regexp->substitute = ufdbStrdup( subst );
  }

  if (lastRewrite->rewrite == NULL)
    lastRewrite->rewrite = regexp;
  else 
    lastRewriteRegExec->next = regexp;
  regexp->httpcode = httpcode;
  regexp->global = global;
  lastRewriteRegExec = regexp;
}


struct sgRewrite * sgRewriteFindName( char * name )
{
  struct sgRewrite * p;

  for (p = Rewrite; p != NULL; p = p->next)
  {
    if (strcmp(name,p->name) == 0)
      return p;
  }

  return NULL;
}



/*
 * Time functions
 */

void sgTime( char * name )
{
  struct Time * t;

  if (Time != NULL)
  {
    if ((struct Time *) sgTimeFindName(name) != NULL)
    {
      ufdbLogFatalError( "%s: time %s is defined in configuration file %s",
		         progname, name, configFile );
      return;
    }
  }
  else 
    numTimeElements = 0;

  t = (struct Time *) ufdbMalloc( sizeof(struct Time) );
  t->name = ufdbStrdup( name );
  t->active = 1;
  t->element = NULL;
  t->next = NULL;

  TimeElement = NULL;
  lastTimeElement = NULL;
  if (Time == NULL) 
  {
    Time = t;
    lastTime = t;
  }
  else
  {
    lastTime->next = t;
    lastTime = t;
  }
}


void sgTimeElementInit( void )
{
  struct TimeElement * te;

  te = (struct TimeElement *) ufdbCalloc( 1, sizeof(struct TimeElement) );
  numTimeElements++;
  if (lastTime->element == NULL)
    lastTime->element = te;
  if (lastTimeElement != NULL)
    lastTimeElement->next = te;
  lastTimeElement = te;
}


void sgTimeElementEnd( void )
{
  time_switch = 0;
  date_switch = 0;

  if (lastTimeElement->fromdate != 0)
  {
    if (lastTimeElement->todate == 0)
      lastTimeElement->todate = lastTimeElement->fromdate + 86399;
    else 
      lastTimeElement->todate = lastTimeElement->todate + 86399;
  }

  if (lastTimeElement->from == 0  &&  lastTimeElement->to == 0)
    lastTimeElement->to = 1439;  /* set time to 23:59 */
}


void sgTimeElementAdd( char * element, char type ) 
{
  struct TimeElement * te;
  char * p;
  char   wday = 0;
  int    h, m, Y, M = 0, D = -1;
  time_t sec;
  char * lineptr;

  te = lastTimeElement;
  switch (type)
  {
  case T_WEEKDAY:
    p = strtok_r( element, " \t,", &lineptr );
    do {
      if (*p == '*') {
	wday = 127;
      } else if (!strncmp(p,"sun",3)) {
	wday = wday | 0x01;
      } else if (!strncmp(p,"mon",3)) {
	wday = wday | 0x02;
      } else if (!strncmp(p,"tue",3)) {
	wday = wday | 0x04;
      } else if (!strncmp(p,"wed",3)) {
	wday = wday | 0x08;
      } else if (!strncmp(p,"thu",3)) {
	wday = wday | 0x10;
      } else if (!strncmp(p,"fri",3)) {
	wday = wday | 0x20;
      } else if (!strncmp(p,"sat",3)) {
	wday = wday | 0x40;
      }
      p = strtok_r( NULL, " \t,", &lineptr );
    } while (p != NULL);
    te->wday = wday;
    break;

  case T_TVAL:
    sscanf( element, "%d:%d", &h, &m );
    if ((h < 0 && h > 24) && (m < 0 && m > 59))
    {
      ufdbLogFatalError( "%s: time format error in %s line %d",
		         progname, configFile, lineno );
      h = 0;
      m = 0;
    }
    if (time_switch == 0) {
      time_switch++;
      te->from = (h * 60) + m ;
    } else {
      time_switch=0;
      te->to = (h * 60) + m ;
    }
    break;

  case T_DVAL:
    sec = date2sec(element);
    if (sec == -1) 
    {
      ufdbLogFatalError( "%s: date format error in %s line %d",
		         progname, configFile, lineno );
      sec = 1;
    }
    if (date_switch == 0) {
      date_switch++;
      te->fromdate = sec;
    } else {
      date_switch = 0;
      te->todate = sec;
    }
    break;

  case T_DVALCRON:
    p = strtok_r( element, "-.", &lineptr );
    Y = atoi(p);
    if (*p == '*')
      Y = -1;
    else
      Y = atoi(p);
    while ((p=strtok_r(NULL,"-.",&lineptr)) != NULL) {
      if (*p == '*')
	if (M == 0)
	  M = -1;
	else 
	  D = -1;
      else
	if (M == 0)
	  M = atoi(p);
	else
	  D = atoi(p);
    }
    te->y=Y; te->m=M; te->d=D;
    break;

  case T_WEEKLY:
    p = element;
    while (*p != '\0') {
      switch (*p) {
      case 'S':
      case 's':
	wday = wday | 0x01;
	break;
      case 'M':
      case 'm':
	wday = wday | 0x02;
	break;
      case 'T':
      case 't':
	wday = wday | 0x04;
	break;
      case 'W':
      case 'w':
	wday = wday | 0x08;
	break;
      case 'H':
      case 'h':
	wday = wday | 0x10;
	break;
      case 'F':
      case 'f':
	wday = wday | 0x20;
	break;
      case 'A':
      case 'a':
	wday = wday | 0x40;
	break;
      default:
	ufdbLogFatalError( "%s: weekday format error in %s line %d",
			   progname, configFile, lineno );
	break;
      }
      p++;
    }
    te->wday = wday;
    break;
  }
}



struct Time *sgTimeFindName(char *name)
{
  struct Time *p;

  for (p=Time; p != NULL; p = p->next)
  {
    if (strcmp(name,p->name) == 0)
      return p;
  }
  return NULL;
}


int sgTimeCmp(const int *a, const int *b)
{
  return *a - *b;
}


void sgTimeElementSortEvents( void )
{
  struct Time * p;
  struct TimeElement * te;
  int i = 0, j;
  int * t;
 
  /* TO-DO: analyze this code */
  if (Time != NULL)
  {
    TimeElementsEvents = (int *) ufdbCalloc( numTimeElements * 2 , sizeof(int) ); 
    for (p = Time; p != NULL; p = p->next) 
    {
      for (te = p->element; te != NULL; te = te->next) 
      {
        TimeElementsEvents[i++] = te->from == 0 ? 1440 : te->from;
        TimeElementsEvents[i++] = te->to == 0   ? 1440 : te->to;
      }
    }
 
    qsort( TimeElementsEvents, numTimeElements * 2, sizeof(int), (void *) &sgTimeCmp );

    t = (int *) ufdbCalloc( numTimeElements * 2, sizeof(int) ); 
    for (i=0,j=0; i < numTimeElements * 2; i++) 
    {
      if (j==0)
      {
        t[j++] = TimeElementsEvents[i];
      }
      else
      {
        if (t[j-1] != TimeElementsEvents[i]) {
 	 t[j++] = TimeElementsEvents[i];
        }
      }
    }
    ufdbFree( TimeElementsEvents );
    numTimeElements = j;
    TimeElementsEvents = t;
  }
}


int sgTimeNextEvent( void )
{
  time_t     t;
  struct tm  lt;
  int        m = 0; 
#if HAVE_SIGACTION
  struct sigaction act;
#endif
  int index = 0;
  int lastval = 0;

  if (Time == NULL)
    return 0;
  t = time(NULL) + globalDebugTimeDelta;

  localtime_r( &t, &lt ); 
  m = (lt.tm_hour * 60) + lt.tm_min ;
  
  for (index=0; index < numTimeElements; index++)
  {
    if (TimeElementsEvents[index] >= m) {
      break;
    }
  }
  lastval = TimeElementsEvents[index];

#if HAVE_SIGACTION
#ifndef SA_NODEFER
#define SA_NODEFER 0
#endif
  act.sa_handler = sgAlarm;
  act.sa_flags = SA_NODEFER | SA_RESTART;
  sigemptyset( &act.sa_mask );
  sigaction(SIGALRM, &act, NULL);
#else
#if HAVE_SIGNAL
  signal(SIGALRM, &sgAlarm);
#else
#endif
#endif

  if (lastval < m)
    m = (((1440 - m ) + lastval) * 60) - lt.tm_sec;
  else
    m = ((lastval - m) * 60) - lt.tm_sec;
  if (m <= 0)
    m = 30;

  ufdbLogError( "recalculating alarm in %d seconds", (unsigned int) m );
  alarm( (unsigned int) m );
  sgTimeCheck( &lt, t );
  sgTimeSetAcl();

  return 0;
}


int sgTimeCheck(struct tm *lt, time_t t)
{
  struct Time *sg;
  struct TimeElement *te;
  int min;

  if (Time == NULL)
    return -1;

  for (sg = Time; sg != NULL; sg = sg->next)
  {
    sg->active = 0;
    for (te = sg->element; te != NULL ; te = te->next)
    {
      if (te->wday != 0) {
	if (((1 << lt->tm_wday ) & te->wday) != 0) {
	  min = (lt->tm_hour * 60 ) + lt->tm_min;
	  if (min >= te->from && min < te->to) {
	    sg->active = 1;
	    break;
	  }
	}
      } else { /* date */
	if (te->fromdate != 0) {
	  if (t >= te->fromdate && t <= te->todate) {
	    min = (lt->tm_hour * 60 ) + lt->tm_min;
	    if (min >= te->from && min < te->to) {
	      sg->active =1;
	      break;
	    }
	  }
	} else { /* cron */
	  if (te->y == -1 || te->y == (lt->tm_year + 1900)) {
	    if (te->m == -1 || te->m == (lt->tm_mon + 1)) {
	      if (te->d == -1 || te->d == (lt->tm_mday)) {
		min = (lt->tm_hour * 60 ) + lt->tm_min;
		if (min >= te->from && min < te->to) {
		  sg->active =1;
		  break;
		}
	      }
	    }
	  }
	}
      }
    }
  }

  return 0;
}


void sgTimeSetAcl( void )
{
  struct Acl *         acl = defaultAcl;
  struct Destination * d;
  struct Source *      s;
  struct sgRewrite *   rew;

  for (acl=Acl; acl != NULL; acl = acl->next)
  {
    if (acl->time != NULL) {
      acl->active = acl->time->active;
      if (acl->within == OUTSIDE)
      {
	if (acl->active)
	  acl->active = 0;
	else
	  acl->active = 1;
      }
      if (acl->next != NULL && acl->next->within == ELSE) 
      {
	if (acl->active == 0) {
	  acl->next->active = 1;
	} else {
	  acl->next->active = 0;
	}
      }
    }
  }

  for (d = Dest; d != NULL; d = d->next)
  {
    if (d->time != NULL) 
    {
      d->active = d->time->active;
      if (d->within == OUTSIDE)
      {
	if (d->active)
	  d->active = 0;
	else
	  d->active = 1;
      }
    }
  }

  for (s = Source; s != NULL; s = s->next)
  {
    if (s->time != NULL) {
      s->active = s->time->active;
      if (s->within == OUTSIDE)
      {
	if (s->active)
	  s->active = 0;
	else
	  s->active = 1;
      }
    }
  }

  for (rew = Rewrite; rew != NULL; rew = rew->next)
  {
    if (rew->time != NULL) {
      rew->active = rew->time->active;
      if (rew->within == OUTSIDE)
      {
	if (rew->active)
	  rew->active = 0;
	else
	  rew->active = 1;
      }
    }
  }
}


void sgTimeElementClone( void )
{
  struct TimeElement * te;
  struct TimeElement * tmp;

  te = lastTimeElement;
  if (te == NULL) 
  {
    ufdbLogFatalError( "No previous TimeElement in sgTimeElementClone !" );
    return;
  }
  else
  {
    sgTimeElementInit();
    lastTimeElement->wday = te->wday;
    lastTimeElement->from = te->from;
    lastTimeElement->to = te->to;
    lastTimeElement->y = te->y;
    lastTimeElement->m = te->m;
    lastTimeElement->d = te->d;
    lastTimeElement->fromdate = te->fromdate;
    lastTimeElement->todate = te->todate;
    tmp = lastTimeElement;
    lastTimeElement = te;
    sgTimeElementEnd();
    lastTimeElement = tmp;
  }
}


void sgTimePrint( void )
{
  struct Time * t;
  struct TimeElement * te;
  char   niso_str[22];

  for (t = Time; t != NULL; t = t->next)
  {
    printf( "Time %s is %s\n", t->name, t->active ? "active" : "inactive" );
    for (te = t->element; te != NULL; te = te->next)
    {
      printf("\tte->wday     = %x\n",te->wday);
      printf("\tte->from     = %d\n",te->from);
      printf("\tte->to       = %d\n",te->to);
      printf("\tte->y,m,d    = %d-%d-%d\n",te->y,te->m,te->d);
      niso( te->fromdate, niso_str );
      printf("\tte->fromdate = %s\n", te->fromdate == 0 ?  "0" : niso_str );
      niso( te->todate, niso_str );
      printf("\tte->todate   = %s\n\n", te->todate == 0 ?  "0" : niso_str );
    }
  }
}


/*
 * IP functions
 */

void sgSetIpType( 
  int         type, 
  char *      file, 
  int         line )
{
  struct Ip * ip;
  char *      p;
  char *      f;
  int         l;
  unsigned long octet;
  unsigned long op;

  ip = sgIpLast( lastSource );
  f = (file == NULL) ? configFile : file;
  l = (line == 0) ? lineno : line;
  if (type == SG_IPTYPE_HOST)
    ip->mask = 0xffffffff;

  if (type == SG_IPTYPE_RANGE)
  {
    if (sgConvDot(ip->str,&op) == NULL)
    {
      ufdbLogFatalError( "%s: address error in %s line %d", progname, f, l );
      ip->mask = 0;
    }
    else 
      ip->mask = op;
    if (ip->net > ip->mask)
    {
      ufdbLogFatalError( "%s: IP range error in %s line %d", progname, f, l );
    }
  }

  if (type == SG_IPTYPE_CLASS)
  {
    p = ip->str;
    if (*p == '/')
      p++;
    if (sgConvDot(p,&op) == NULL)
    {
      ufdbLogFatalError( "%s: address error in %s line %d", progname, f, l );
      ip->mask = 0;
    }
    else 
      ip->mask = op;
  }

  if (type == SG_IPTYPE_CIDR)
  {
    p = ip->str;
    if (*p == '/')
      p++;
    octet = atoi( p );
    if (octet < 0 || octet > 32) 
    {
      ufdbLogFatalError( "%s: prefix error %s in %s line %d", progname, p, f, l );
      octet = 0;
    }
    if (octet == 32)
      ip->mask = 0xffffffff;
    else
      ip->mask = 0xffffffff ^ (0xffffffff >> octet);
    ip->net = ip->net & ip->mask;
  }

  ip->type = type;
  ip->next = (struct Ip *) ufdbCalloc( 1, sizeof(struct Ip) );

  /* TO-DO: fix messy code where the last struct must contain zeros */
}


void sgIp( 
  char *      name )
{
  struct Ip * ip;
  ulong       op;

  if (lastSource->ip == NULL) 
  {
    ip = (struct Ip *) ufdbCalloc( 1, sizeof(struct Ip) );
    ip->next = NULL;
    ip->str = NULL;
    lastSource->ip = ip;
    lastSource->lastip = ip;
  }
  else
  {
    ip = sgIpLast( lastSource );
  }

  if (ip->net_is_set == 0) 
  {
    ip->net_is_set = 1;
    if (sgConvDot(name,&op) == NULL) 
    {
      ufdbLogFatalError( "%s: address error in %s line %d", progname, configFile, lineno );
      ip->net = 0;
    }
    else 
      ip->net = op;
  }
  else
  {
    ip->str = (char *) ufdbMalloc( strlen(name) + 1 );
    strcpy( ip->str, name );
  }
}


struct Ip * sgIpLast( struct Source * s )
{
  struct Ip * ip, *ret;

  ret = NULL;
  for (ip = s->ip; ip != NULL; ip = ip->next)
    ret = ip;

  return ret;
}


/*
 * ACL functions
 */


void sgAcl( 
  char *          name,
  char *          value, 
  int             within )
{
  struct Acl *    acl;
  struct Source * source = NULL;
  struct Time *   time = NULL;
  int             def;
  char *          s;

  def = 0;
  if (name != NULL)
  {
    /* due to some strange things in the yacc code */
    if ((s=(char *) strchr(name,' ')) != NULL)
      *s = '\0';    
    if ((s=(char *) strchr(name,'\t')) != NULL)
      *s = '\0';    
    /*					TO-DO: find out why commented out
    if (Acl != NULL) {
      if ((struct Acl *) sgAclFindName(name) != NULL)
      {
	ufdbLogFatalError( "%s: ACL %s is defined in configuration file %s",
			   progname, name, configFile );
      }
    }
    */
  }

  if (lastAcl != NULL && name == NULL && within == ELSE) 
    name = lastAcl->name;
  acl = (struct Acl *) ufdbMalloc( sizeof(struct Acl) );

  if (strcmp(name,"default") == 0)
  {
    defaultAcl = acl;
    def++;
  }
  else
  {
    if ((source = sgSourceFindName(name)) == NULL && !def) 
    {
      ufdbLogFatalError( "%s: ACL source %s is not defined in configuration file %s",
		         progname, name, configFile );
      return;
    }
  }

  acl->name = ufdbMalloc( strlen(name) + 1 );
  strcpy( acl->name, name );
  acl->active = within == ELSE ? 0 : 1;
  acl->source = source;
  acl->pass = NULL;
  acl->rewriteDefault = 1;
  acl->rewrite = NULL;
  acl->redirect = NULL;
  acl->time = NULL;
  acl->within = within;
  acl->logfile = NULL;
  acl->next = NULL;
  if (value != NULL) 
  {
    if ((time = sgTimeFindName(value)) == NULL) 
    {
      ufdbLogFatalError( "%s: ACL time %s is not defined in configuration file %s",
		       progname, value, configFile );
      return;
    }
    acl->time = time;
  }

  if (Acl == NULL) {
    Acl = acl;
    lastAcl = acl;
  } else {
    lastAcl->next = acl;
    lastAcl = acl;
  }
}


void sgAclSetValue( 
  char *               what,
  char *               value, 
  int                  allowed ) 
{
  struct Destination * dest = NULL;
  struct sgRewrite *   rewrite = NULL;
  struct AclDest *     acldest;
  int                  type;
  
  type = ACL_TYPE_TERMINATOR;

  if (strcmp(what,"pass") == 0)
  {
    if (strcmp(value,"any")==0 || strcmp(value,"all")==0)
      allowed = 1;
    else if (strcmp(value,"none") == 0)
      allowed = 0;
    else if (strcmp(value,"in-addr") == 0) {
      type = ACL_TYPE_INADDR;
    }
    else
    {
      if ((dest = sgDestFindName(value)) == NULL) 
      {
	ufdbLogFatalError( "%s: ACL destination %s is not defined in configuration file %s",
			   progname, value, configFile );
        return;
      } 
      type = ACL_TYPE_DEFAULT;
    }

    acldest = ufdbMalloc( sizeof(struct AclDest) );
    acldest->name = (char *) ufdbMalloc( strlen(value) + 1 );
    strcpy( acldest->name, value );
    acldest->dest = dest;
    acldest->access = allowed;
    acldest->type = type;
    acldest->next = NULL;

    if (lastAcl->pass == NULL) {
      lastAcl->pass = acldest;
    } else {
      lastAclDest->next = acldest;
    }
    lastAclDest = acldest;
  }

  if (strcmp(what,"rewrite") == 0)
  {
    if (strcmp(value,"none") == 0)
    {
      lastAcl->rewriteDefault = 0;
      lastAcl->rewrite = NULL;
    }
    else
    {
      if ((rewrite = sgRewriteFindName(value)) == NULL) 
      {
	ufdbLogFatalError( "%s: Rewrite %s is not defined in configuration file %s",
			   progname, value, configFile );
      }
      lastAcl->rewriteDefault = 0;
      lastAcl->rewrite = rewrite;
    }
  }

  if (strcmp(what,"redirect") == 0)
  {
    if (strcmp(value,"default") != 0)
    {
      lastAcl->redirect = (char *) ufdbMalloc( strlen(value) + 1 );
      strcpy( lastAcl->redirect, value );
    } else {
      lastAcl->redirect = NULL;
    }
  }
}


struct Acl * sgAclFindName( 
  char *       name )
{
  struct Acl * p;

  for (p=Acl; p != NULL; p = p->next)
  {
    if (strcmp(name,p->name) == 0)
      return p;
  }
  return NULL;
}



/*
 * called by main loop: find the ACL that matches a source
 */
#if 0
struct Acl * sgAclCheckSource( struct Source * source )
{
  struct Acl * acl;

  if (source != NULL)
  {
    for (acl=Acl; acl != NULL; acl = acl->next)
    {
      if (acl->source == source && acl->active) 
	  return acl;
    }
  }

  return defaultAcl;
}
#else
struct Acl * sgAclCheckSource( 
   struct Source * source )
{
   struct Acl *    acl = defaultAcl;
   int             found = 0;

   if (source != NULL) 
   {
     for (acl=Acl; acl != NULL; acl = acl->next)
     {
       if (acl->source == source)
       {
	  if (acl->active) 
	  {
	    found++;
	    break;
	  }
	  else
	  {
	    if (acl->next->source == source && acl->next->active != 0)
	    {
	      found++;
	      acl = acl->next;
	      break;
	    }
	  }
        }
      }
   }

   if (!found)
     acl = defaultAcl;

   return acl;
}
#endif


/*
 * called by main loop: scan the full access matrix for the URL in parameter 'req'
 * return NULL if access is granted, otherwise a redirection URL string.
 */
char * sgAclAccess( 
  struct Source *    src, 
  struct Acl *       acl, 
  struct SquidInfo * req, 
  char *             buffer )
{
  int    access;
  int    result;
  char * redirect = NULL;
  char * dbdata = NULL;
  char * p;
  struct sgRewrite *    rewrite = NULL;
  struct AclDest *      aclpass = NULL;
  struct UFDBmemTable * mt;
  char   newstring[MAX_BUF];
  char   newredir[MAX_BUF + MAX_BUF];

  if (acl == NULL)
    return NULL;

  if (acl->pass == NULL)
    acl->pass = defaultAcl->pass;

  access = 1; 			/* let's start optimistic and grant access */
  if (acl->pass != NULL)
  {
    for (aclpass = acl->pass; aclpass != NULL; aclpass = aclpass->next)
    {
      if (aclpass->dest != NULL && !aclpass->dest->active)
	continue;

      if (aclpass->type == ACL_TYPE_TERMINATOR) {
	access = aclpass->access;
	break;
      }
      if (aclpass->type == ACL_TYPE_INADDR) {
	if (req->dot) {
	  access = aclpass->access;
	  break;
	}
	continue;
      }

#if 0
      /* be very careful not to touch table memory during a reconfigure */
      if (UFDBreconfig)
      {
	 *buffer = '\0';
	 return NULL;
      }
#endif

      /* domain name lookup for this source */
      if (aclpass->dest->domainlistDb != NULL) 
      {
        mt = (struct UFDBmemTable *) aclpass->dest->domainlistDb->dbcp;
        result = UFDBlookupRevUrl( &(mt->table.nextLevel[0]), req->revUrl );

	if (result) 
	{
	  if (aclpass->access) {
	    access++;
	    break; 
	  } else {
	     access = 0;
	     break;
	  }
	}
      }

      if (UFDBgetTunnelCheckMethod() != UFDB_API_HTTPS_CHECK_OFF  &&  
          strcmp( req->protocol, "https" ) == 0  &&  
	  strcmp( aclpass->name, "proxies" ) == 0)
      {
         int httpsStatus;

	 httpsStatus = UFDBcheckForHTTPStunnel( req->orig_domain, req->port,
	    UFDBgetTunnelCheckMethod() == UFDB_API_HTTPS_CHECK_AGRESSIVE ? 0 : UFDB_API_ALLOW_QUEUING );
	 if (httpsStatus == UFDB_API_ERR_TUNNEL)
	 {
	    if (UFDBgetTunnelCheckMethod() != UFDB_API_HTTPS_LOG_ONLY)
	    {
	       access = 0;
	       break;
	    }
	 }
      }

      /* expr lookup for this source */
      if (aclpass->dest->regExp != NULL  &&  access) 
      {
	result = ufdbRegExpMatch( aclpass->dest->regExp, req->url );
#if 0
	ufdbLogError( "ufdbRegExpMatch( %s  %s ) = %d", aclpass->dest->regExp->pattern, req->url, result );
#endif
	if (result) 
	{
	  if (aclpass->access) {
	    access++;
	    break;
	  } else {
	    access = 0;
	    break;
	  }
	}
      }

#ifdef UFDB_DOMAIN_IP_LOOKUP
      /* new: IP address lookup in the domains database */
      if (aclpass->dest->domainlistDb != NULL  &&  access) 
      {
	struct hostent thishost;
	int rv;

	rv = gethostbyname_r( req->domain );	/* NOT USED because potentially blocking !!! */
	if (rv != 0)
	{
	   /* future: do it for that whole array h_addr_list[] */
	   result = UFDBmemDBfind( aclpass->dest->domainlistDb, thishost->h_addr_list[0], &dbdata );
	   if (result) 
	   {
	     if (aclpass->access) 
	     {
	       access++;
	       break; 
	     } else {
	       access = 0;
	       break;
	     }
	   }
        }
      }
#endif

    }

    if (!access) 
    {
      if (dbdata != NULL)
	redirect = dbdata;
      else if (aclpass->dest != NULL && aclpass->dest->redirect != NULL)
	redirect = aclpass->dest->redirect;
      else if (aclpass->dest != NULL && aclpass->dest->rewrite != NULL &&
	      (redirect = 
	       sgRewriteExpression(aclpass->dest->rewrite,req->orig,newstring)) != NULL) {
	;
      }
      else if (acl->redirect == NULL)
	redirect = defaultAcl->redirect;
      else
	redirect = acl->redirect;
    }
  }
  else
  {  
    /* acl->pass == NULL, probably defaultAcl->pass == NULL */
    access = 0;
    redirect = defaultAcl->redirect;
  }

  if (acl->rewrite == NULL)
    rewrite = defaultAcl->rewrite;
  else
    rewrite = acl->rewrite;

  if (rewrite != NULL && access)
  {
    if ((p = sgRewriteExpression(rewrite,req->orig,newstring)) != NULL) 
    {
      redirect = p;
      if (rewrite->logfile != NULL) 
      {
	globalLogFile = rewrite->logfile;
	ufdbLogRequest( globalLogFile, req, acl, aclpass, rewrite );
      }
    }
  }
  else if (redirect != NULL) 
  {
    redirect = sgParseRedirect( redirect, req, acl, aclpass, newredir );
    if (src != NULL && src->logfile != NULL)
      globalLogFile = src->logfile;
    if (aclpass == NULL || aclpass->dest == NULL) 
    {
      if (defaultAcl->logfile != NULL)
	globalLogFile = defaultAcl->logfile;
    } else {
      if (aclpass->dest->logfile != NULL)
	globalLogFile = aclpass->dest->logfile;
    }
    if (globalLogFile != NULL)
      ufdbLogRequest( globalLogFile, req, acl, aclpass, NULL );
  }

  if (redirect != NULL)
  {
     strcpy( buffer, redirect );
     req->aclpass = aclpass;
     return buffer;
  }

  *buffer = '\0';
  return NULL;
}


void yyerror( char * s )
{
   ufdbLogFatalError( "%s in configuration file %s line %d", s, configFile, lineno );
}


int yywrap()
{
  return 1;
}


